unit IconDialog;

{**********************************************************}
{                                                          }
{  TIconDialog Unit                                        }
{  Copyright 1999 Workshell Software.                     }
{							   }
{  Version 1.0						   }
{                                                          }
{                                                          }
{  Web      -> http://www.workshell.uni.cc/                }
{  E - Mail -> icondlg@kinsella.u-net.com                  }
{                                                          }
{**********************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, ShellAPI;

type
  TIconDialog = class(TComponent)
  private
    { Private declarations }
    FIcon: TIcon;
    FFileName: String;
    FIndex: Integer;
    function GetAnyFile: String;
  protected
    { Protected declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    { Public declarations }
    function Execute: Boolean;
    property Icon: TIcon read FIcon;
  published
    { Published declarations }
    property FileName: String read FFileName write FFileName;
    property IconIndex: Integer read FIndex write FIndex;
  end;

procedure Register;

implementation

function PickIconDlgA(OwnerWnd: HWND; lpstrFile: PAnsiChar; var nMaxFile: LongInt;
 var lpdwIconIndex: LongInt): LongBool; stdcall; external 'SHELL32.DLL' index 62;

constructor TIconDialog.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
FIcon := TIcon.Create;
end;

destructor TIconDialog.Destroy;
begin
FIcon.Free;
inherited Destroy;
end;

function TIconDialog.Execute: Boolean;
var
zFileName: array [0..MAX_PATH - 1] of Char;
zSize, zIndex: LongInt;
begin
zSize := MAX_PATH;
StrPCopy(zFileName,GetAnyFile);
if FileName <> '' then
 begin
  StrPCopy(zFileName,FileName);
 end;
Result := PickIconDlgA(0,zFilename,zSize,zIndex);
FileName := StrPas(zFileName);
IconIndex := zIndex;
if (FileName <> '') and (IconIndex <> -1) then
begin
FIcon.Handle := ExtractIcon(hInstance,zFileName,zIndex);
end;
end;

{ NOTE: GetAnyFile is for getting SHELL32.DLL if no filename is specified on
        startup becuase PickIconDlgA requires one. }

function TIconDialog.GetAnyFile: String;
var
 zSysDir: array [0..MAX_PATH - 1] of Char;
 SysDir: String;
begin
GetSystemDirectory(zSysDir,255);
SysDir := StrPas(zSysDir);
if SysDir[Length(SysDir)] <> '\' then
 begin
  SysDir := SysDir + '\';
 end;
Result := SysDir + 'SHELL32.DLL';
end;

procedure Register;
begin
 RegisterComponents('Dialogs', [TIconDialog]);
end;

end.
